-- --------------------------------------------------
-- Innkeep Professions
-- --------------------------------------------------
InnkeepProfessions = {}

function InnkeepProfessions:GetOpenProfessionRecipes()
  local skills = {}
  for i=1, GetNumTradeSkills() do
    local skillName, skillType = GetTradeSkillInfo(i)
    if skillType ~= "header" then
      table.insert(skills, skillName)
    end
  end
  for i=1, GetNumCrafts() do
    local craftName, _, craftType = GetCraftInfo(i)
    if craftType ~= "header" then
      table.insert(skills, craftName)
    end
  end
  return skills;
end

function InnkeepProfessions:GetOpenProfessionInfo()
  name = GetTradeSkillLine()
  if name == 'UNKNOWN' then
    return nil
  end
  return {
    name = name,
    recipes = self:GetOpenProfessionRecipes()
  }
end
